]> git.ipfire.org Git - people/ms/network.git/blob - src/functions/functions.vpn-security-policies
security-policies: Show integrity with description
[people/ms/network.git] / src / functions / functions.vpn-security-policies
1 #!/bin/bash
2 ###############################################################################
3 # #
4 # IPFire.org - A linux based firewall #
5 # Copyright (C) 2017 IPFire Network Development Team #
6 # #
7 # This program is free software: you can redistribute it and/or modify #
8 # it under the terms of the GNU General Public License as published by #
9 # the Free Software Foundation, either version 3 of the License, or #
10 # (at your option) any later version. #
11 # #
12 # This program is distributed in the hope that it will be useful, #
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15 # GNU General Public License for more details. #
16 # #
17 # You should have received a copy of the GNU General Public License #
18 # along with this program. If not, see <http://www.gnu.org/licenses/>. #
19 # #
20 ###############################################################################
21
22 VPN_SECURITY_POLICIES_CONFIG_SETTINGS="CIPHER COMPRESSION GROUP_TYPE INTEGRITY KEY_EXCHANGE LIFETIME PFS"
23 VPN_SECURITY_POLICIES_READONLY="system"
24
25 VPN_DEFAULT_SECURITY_POLICY="system"
26
27 declare -A VPN_SUPPORTED_CIPHERS=(
28 # 3DES-CBC
29 [3DES-CBC]="168 bit 3DES-EDE-CBC"
30
31 # AES-CBC
32 [AES256-CBC]="256 bit AES-CBC"
33 [AES192-CBC]="192 bit AES-CBC"
34 [AES128-CBC]="128 bit AES-CBC"
35
36 # AES-CTR
37 [AES256-CTR]="256 bit AES-COUNTER"
38 [AES192-CTR]="192 bit AES-COUNTER"
39 [AES128-CTR]="128 bit AES-COUNTER"
40
41 # AES-GCM
42 [AES256-GCM128]="256 bit AES-GCM with 128 bit ICV"
43 [AES192-GCM128]="192 bit AES-GCM with 128 bit ICV"
44 [AES128-GCM128]="128 bit AES-GCM with 128 bit ICV"
45 [AES256-GCM96]="256 bit AES-GCM with 96 bit ICV"
46 [AES192-GCM96]="192 bit AES-GCM with 96 bit ICV"
47 [AES128-GCM96]="128 bit AES-GCM with 96 bit ICV"
48 [AES256-GCM64]="256 bit AES-GCM with 64 bit ICV"
49 [AES192-GCM64]="192 bit AES-GCM with 64 bit ICV"
50 [AES128-GCM64]="128 bit AES-GCM with 64 bit ICV"
51
52 # AES-CCM
53 [AES256-CCM128]="256 bit AES-CCM with 128 bit ICV"
54 [AES192-CCM128]="192 bit AES-CCM with 128 bit ICV"
55 [AES128-CCM128]="128 bit AES-CCM with 128 bit ICV"
56 [AES256-CCM96]="256 bit AES-CCM with 96 bit ICV"
57 [AES192-CCM96]="192 bit AES-CCM with 96 bit ICV"
58 [AES128-CCM96]="128 bit AES-CCM with 96 bit ICV"
59 [AES256-CCM64]="256 bit AES-CCM with 64 bit ICV"
60 [AES192-CCM64]="192 bit AES-CCM with 64 bit ICV"
61 [AES128-CCM64]="128 bit AES-CCM with 64 bit ICV"
62
63 # CAMELLIA-CBC
64 [CAMELLIA256-CBC]="256 bit CAMELLIA-CBC"
65 [CAMELLIA192-CBC]="192 bit CAMELLIA-CBC"
66 [CAMELLIA128-CBC]="128 bit CAMELLIA-CBC"
67
68 # CAMELLIA-CTR
69 [CAMELLIA256-CTR]="256 bit CAMELLIA-COUNTER"
70 [CAMELLIA192-CTR]="192 bit CAMELLIA-COUNTER"
71 [CAMELLIA128-CTR]="128 bit CAMELLIA-COUNTER"
72
73 # CAMELLIA-GCM
74 [CAMELLIA256-GCM128]="256 bit CAMELLIA-GCM with 128 bit ICV"
75 [CAMELLIA192-GCM128]="192 bit CAMELLIA-GCM with 128 bit ICV"
76 [CAMELLIA128-GCM128]="128 bit CAMELLIA-GCM with 128 bit ICV"
77 [CAMELLIA256-GCM96]="256 bit CAMELLIA-GCM with 96 bit ICV"
78 [CAMELLIA192-GCM96]="192 bit CAMELLIA-GCM with 96 bit ICV"
79 [CAMELLIA128-GCM96]="128 bit CAMELLIA-GCM with 96 bit ICV"
80 [CAMELLIA256-GCM64]="256 bit CAMELLIA-GCM with 64 bit ICV"
81 [CAMELLIA192-GCM64]="192 bit CAMELLIA-GCM with 64 bit ICV"
82 [CAMELLIA128-GCM64]="128 bit CAMELLIA-GCM with 64 bit ICV"
83
84 # CAMELLIA-CCM
85 [CAMELLIA256-CCM128]="256 bit CAMELLIA-CCM with 128 bit ICV"
86 [CAMELLIA192-CCM128]="192 bit CAMELLIA-CCM with 128 bit ICV"
87 [CAMELLIA128-CCM128]="128 bit CAMELLIA-CCM with 128 bit ICV"
88 [CAMELLIA256-CCM96]="256 bit CAMELLIA-CCM with 96 bit ICV"
89 [CAMELLIA192-CCM96]="192 bit CAMELLIA-CCM with 96 bit ICV"
90 [CAMELLIA128-CCM96]="128 bit CAMELLIA-CCM with 96 bit ICV"
91 [CAMELLIA256-CCM64]="256 bit CAMELLIA-CCM with 64 bit ICV"
92 [CAMELLIA192-CCM64]="192 bit CAMELLIA-CCM with 64 bit ICV"
93 [CAMELLIA128-CCM64]="128 bit CAMELLIA-CCM with 64 bit ICV"
94 )
95
96 declare -A VPN_SUPPORTED_INTEGRITY=(
97 [MD5]="MD5-HMAC"
98
99 # SHA
100 [SHA1]="SHA1-HMAC"
101 [SHA512]="256 bit SHA2-HMAC"
102 [SHA384]="384 bit SHA2-HMAC"
103 [SHA256]="256 bit SHA2-HMAC"
104
105 # AES
106 [AES-XCBC]="AES-XCBC"
107 [AES-CMAC]="AES-CMAC"
108 [AES256-GMAC]="256 bit AES-GMAC"
109 [AES192-GMAC]="192 bit AES-GMAC"
110 [AES128-GMAC]="128 bit AES-GMAC"
111 )
112
113 VPN_SUPPORTED_GROUP_TYPES="MODP8192 MODP4096"
114
115 # This functions checks if a policy is readonly
116 # returns true when yes and false when no
117 vpn_security_policies_check_readonly() {
118 if isoneof name ${VPN_SECURITY_POLICIES_READONLY}; then
119 return ${EXIT_TRUE}
120 else
121 return ${EXIT_FALSE}
122 fi
123 }
124
125 # This function writes all values to a via ${name} specificated vpn security policy configuration file
126 vpn_security_policies_write_config() {
127 assert [ $# -ge 1 ]
128
129 local name="${1}"
130
131 if ! vpn_security_policy_exists "${name}"; then
132 log ERROR "No such vpn security policy: ${name}"
133 return ${EXIT_ERROR}
134 fi
135
136 if vpn_security_policies_check_readonly "${name}"; then
137 log ERROR "The ${name} vpn security policy cannot be changed."
138 return ${EXIT_ERROR}
139 fi
140
141 local path="$(vpn_security_policies_path "${name}")"
142 if [ ! -w ${path} ]; then
143 log ERROR "${path} is not writeable"
144 return ${EXIT_ERROR}
145 fi
146
147 if ! settings_write "${path}" ${VPN_SECURITY_POLICIES_CONFIG_SETTINGS}; then
148 log ERROR "Could not write configuration settings for vpn security policy ${name}"
149 return ${EXIT_ERROR}
150 fi
151
152 # TODO everytime we successfully write a config we should call some trigger to take the changes into effect
153 }
154
155 # This funtion writes the value for one key to a via ${name} specificated vpn security policy configuration file
156 vpn_security_policies_write_config_key() {
157 assert [ $# -ge 3 ]
158
159 local name=${1}
160 local key=${2}
161 shift 2
162
163 local value="$@"
164
165 if ! vpn_security_policy_exists "${name}"; then
166 log ERROR "No such vpn security policy: ${name}"
167 return ${EXIT_ERROR}
168 fi
169
170 log DEBUG "Set '${key}' to new value '${value}' in vpn security policy ${name}"
171
172 local ${VPN_SECURITY_POLICIES_CONFIG_SETTINGS}
173
174 # Read the config settings
175 if ! vpn_security_policies_read_config "${name}"; then
176 return ${EXIT_ERROR}
177 fi
178
179 # Set the key to a new value
180 assign "${key}" "${value}"
181
182 if ! vpn_security_policies_write_config "${name}"; then
183 return ${EXIT_ERROR}
184 fi
185
186 return ${EXIT_TRUE}
187 }
188
189 # Reads one or more keys out of a settings file or all if no key is provided.
190 vpn_security_policies_read_config() {
191 assert [ $# -ge 1 ]
192
193 local name="${1}"
194 shift 1
195
196 if ! vpn_security_policy_exists "${name}"; then
197 log ERROR "No such vpn security policy: ${name}"
198 return ${EXIT_ERROR}
199 fi
200
201
202 local args
203 if [ $# -eq 0 ] && [ -n "${VPN_SECURITY_POLICIES_CONFIG_SETTINGS}" ]; then
204 list_append args ${VPN_SECURITY_POLICIES_CONFIG_SETTINGS}
205 else
206 list_append args $@
207 fi
208
209 local path="$(vpn_security_policies_path ${name})"
210
211 if ! settings_read "${path}" ${args}; then
212 log ERROR "Could not read settings for vpn security policy ${name}"
213 return ${EXIT_ERROR}
214 fi
215 }
216
217 # Returns the path to a the configuration fora given name
218 vpn_security_policies_path() {
219 assert [ $# -eq 1 ]
220
221 local name=${1}
222
223 if vpn_security_policies_check_readonly "${name}"; then
224 echo "${NETWORK_SHARE_DIR}/vpn/security-policies/${name}"
225 else
226 echo "${NETWORK_CONFIG_DIR}/vpn/security-policies/${name}"
227 fi
228 }
229
230 # Print the content of a vpn security policy configuration file in a nice way
231 vpn_security_policies_show() {
232 assert [ $# -eq 1 ]
233
234 local name=${1}
235
236 local ${VPN_SECURITY_POLICIES_CONFIG_SETTINGS}
237 if ! vpn_security_policies_read_config ${name}; then
238 return ${EXIT_ERROR}
239 fi
240
241 cli_print_fmt1 0 "Security Policy: ${name}"
242 cli_space
243
244 # This could be done in a loop but a loop is much more complicated
245 # because we print 'Group Types' but the variable is named 'GROUP_TYPES'
246 cli_print_fmt1 1 "Ciphers:"
247 local cipher
248 for cipher in ${CIPHER}; do
249 cli_print_fmt1 2 "${VPN_SUPPORTED_CIPHERS[${cipher}]-${cipher}}"
250 done
251 cli_space
252
253 cli_print_fmt1 1 "Integrity:"
254 local integrity
255 for integrity in ${INTEGRITY}; do
256 cli_print_fmt1 2 "${VPN_SUPPORTED_INTEGRITY[${integrity}]-${integrity}}"
257 done
258 cli_space
259
260 cli_print_fmt1 1 "Group Types:"
261 cli_print_fmt1 2 "${GROUP_TYPE}"
262 cli_space
263
264 cli_print_fmt1 1 "Key Exchange:" "${KEY_EXCHANGE}"
265
266 # Key Lifetime
267 if isinteger LIFETIME && [ ${LIFETIME} -gt 0 ]; then
268 cli_print_fmt1 1 "Key Lifetime:" "$(format_time ${LIFETIME})"
269 else
270 log ERROR "The value for Key Lifetime is not a valid integer greater zero."
271 fi
272
273 # PFS
274 if enabled PFS; then
275 cli_print_fmt1 1 "Perfect Forward Secrecy:" "enabled"
276 else
277 cli_print_fmt1 1 "Perfect Forward Secrecy:" "disabled"
278 fi
279 cli_space
280
281 # Compression
282 if enabled COMPRESSION; then
283 cli_print_fmt1 1 "Compression:" "enabled"
284 else
285 cli_print_fmt1 1 "Compression:" "disabled"
286 fi
287 cli_space
288 }
289
290 # This function checks if a vpn security policy exists
291 # Returns True when yes and false when not
292 vpn_security_policy_exists() {
293 assert [ $# -eq 1 ]
294
295 local name=${1}
296
297 local path=$(vpn_security_policies_path "${name}")
298
299 [ -f ${path} ] && return ${EXIT_TRUE} || return ${EXIT_FALSE}
300 }
301
302
303 # This function parses the parameters for the 'cipher' command
304 vpn_security_policies_cipher(){
305 local name=${1}
306 shift
307
308 if [ $# -eq 0 ]; then
309 log ERROR "You must pass at least one value after cipher"
310 return ${EXIT_ERROR}
311 fi
312
313 local CIPHER
314 if ! vpn_security_policies_read_config ${name} "CIPHER"; then
315 return ${EXIT_ERROR}
316 fi
317
318 # Remove duplicated entries to proceed the list safely
319 CIPHER="$(list_unique ${CIPHER})"
320
321 while [ $# -gt 0 ]; do
322 case "${1}" in
323 -*)
324 value=${1#-}
325 # Check if the cipher is in the list of ciphers and
326 # check if the list has after removing this cipher at least one valid value
327 if list_match ${value} ${CIPHER}; then
328 list_remove CIPHER ${value}
329 else
330 # We do not break here because this error does not break the processing of the next maybe valid values.
331 log ERROR "Can not remove ${value} from the list of Ciphers because ${value} is not in the list."
332 fi
333 ;;
334 +*)
335 value=${1#+}
336 # Check if the Ciphers is in the list of supported ciphers.
337 if ! isoneof value ${!VPN_SUPPORTED_CIPHERS[@]}; then
338 # We do not break here because this error does not break the processing of the next maybe valid values.
339 log ERROR "${value} is not a supported cipher and can thats why not added to the list of ciphers."
340 else
341 if list_match ${value} ${CIPHER}; then
342 log WARNING "${value} is already in the list of ciphers of this policy."
343 else
344 list_append CIPHER ${value}
345 fi
346 fi
347 ;;
348 esac
349 shift
350 done
351
352 # Check if the list contain at least one valid cipher
353 if [ $(list_length ${CIPHER}) -ge 1 ]; then
354 if ! vpn_security_policies_write_config_key ${name} "CIPHER" ${CIPHER}; then
355 log ERROR "The changes for the vpn security policy ${name} could not be written."
356 fi
357 else
358 log ERROR "After proceding all ciphers the list is empty and thats why no changes are written."
359 return ${EXIT_ERROR}
360 fi
361 }
362
363 # This function parses the parameters for the 'compression' command
364 vpn_security_policies_compression(){
365 local name=${1}
366 local value=${2}
367
368 # Check if we get only one argument after compression <name>
369 if [ ! $# -eq 2 ]; then
370 log ERROR "The number of arguments do not match. Only one argument after compression is allowed."
371 return ${EXIT_ERROR}
372 fi
373
374 if ! isbool value; then
375 # We suggest only two values to avoid overburding the user.
376 log ERROR "Invalid Argument ${value}"
377 return ${EXIT_ERROR}
378 fi
379
380 vpn_security_policies_write_config_key "${name}" "COMPRESSION" "${value}"
381 }
382
383 # This function parses the parameters for the 'group-type' command
384 vpn_security_policies_group_type(){
385 local name=${1}
386 shift
387
388 if [ $# -eq 0 ]; then
389 log ERROR "You must pass at least one value after group-type"
390 return ${EXIT_ERROR}
391 fi
392
393 local GROUP_TYPE
394 if ! vpn_security_policies_read_config ${name} "GROUP_TYPE"; then
395 return ${EXIT_ERROR}
396 fi
397
398 # Remove duplicated entries to proceed the list safely
399 GROUP_TYPE="$(list_unique ${GROUP_TYPE})"
400
401 while [ $# -gt 0 ]; do
402 case "${1}" in
403 -*)
404 value=${1#-}
405 # Check if the group type is in the list of group types and
406 # check if the list has after removing this group type at leatst one valid value
407 if list_match ${value} ${GROUP_TYPE}; then
408 list_remove GROUP_TYPE ${value}
409 else
410 # We do not break here because this error does not break the processing of the next maybe valid values.
411 log ERROR "Can not remove ${value} from the list of group types because ${value} is not in the list."
412 fi
413 ;;
414 +*)
415 value=${1#+}
416 # Check if the group type is in the list of supported group types.
417 if ! isoneof value ${VPN_SUPPORTED_GROUP_TYPES}; then
418 # We do not break here because the processing of other maybe valid values are indepent from this error.
419 log ERROR "${value} is not a supported group type and can thats why not added to the list of group types."
420 else
421 if list_match ${value} ${GROUP_TYPE}; then
422 log WARNING "${value} is already in the list of group-types of this policy."
423 else
424 list_append GROUP_TYPE ${value}
425 fi
426 fi
427 ;;
428 esac
429 shift
430 done
431
432 # Check if the list contain at least one valid group-type
433 if [ $(list_length ${GROUP_TYPE}) -ge 1 ]; then
434 if ! vpn_security_policies_write_config_key ${name} "GROUP_TYPE" ${GROUP_TYPE}; then
435 log ERROR "The changes for the vpn security policy ${name} could not be written."
436 fi
437 else
438 log ERROR "After proceding all group types the list is empty and thats why no changes are written."
439 return ${EXIT_ERROR}
440 fi
441 }
442
443 # This function parses the parameters for the 'integrity' command
444 vpn_security_policies_integrity(){
445 local name=${1}
446 shift
447
448 if [ $# -eq 0 ]; then
449 log ERROR "You must pass at least one value after integrity."
450 return ${EXIT_ERROR}
451 fi
452
453 local INTEGRITY
454 if ! vpn_security_policies_read_config ${name} "INTEGRITY"; then
455 return ${EXIT_ERROR}
456 fi
457
458 # Remove duplicated entries to proceed the list safely
459 INTEGRITY="$(list_unique ${INTEGRITY})"
460
461 while [ $# -gt 0 ]; do
462 case "${1}" in
463 -*)
464 value=${1#-}
465 # Check if the integrity hash is in the list of integrity hashes and
466 # check if the list has after removing this integrity hash at least one valid value
467 if list_match ${value} ${INTEGRITY}; then
468 list_remove INTEGRITY ${value}
469 else
470 # We do not break here because the processing of other maybe valid values are indepent from this error.
471 log ERROR "Can not remove ${value} from the list of integrity hashes because ${value} is not in the list."
472 fi
473 ;;
474 +*)
475 value=${1#+}
476 # Check if the Ciphers is in the list of supported integrity hashes.
477 if ! isoneof value ${!VPN_SUPPORTED_INTEGRITY[@]}; then
478 # We do not break here because the processing of other maybe valid values are indepent from this error.
479 log ERROR "${value} is not a supported integrity hash and can thats why not added to the list of integrity hashes."
480 else
481 if list_match ${value} ${INTEGRITY}; then
482 log WARNING "${value} is already in the list of integrety hashes of this policy."
483 else
484 list_append INTEGRITY ${value}
485 fi
486 fi
487 ;;
488 esac
489 shift
490 done
491
492 # Check if the list contain at least one valid group-type
493 if [ $(list_length ${INTEGRITY}) -ge 1 ]; then
494 if ! vpn_security_policies_write_config_key ${name} "INTEGRITY" ${INTEGRITY}; then
495 log ERROR "The changes for the vpn security policy ${name} could not be written."
496 fi
497 else
498 log ERROR "After proceding all integrity hashes the list is empty and thats why no changes are written."
499 return ${EXIT_ERROR}
500 fi
501 }
502
503 # This function parses the parameters for the 'key-exchange' command
504 vpn_security_policies_key_exchange() {
505 local name=${1}
506 local value=${2}
507
508 # Check if we get only one argument after key-exchange <name>
509 if [ ! $# -eq 2 ]; then
510 log ERROR "The number of arguments do not match. Only argument after key-exchange is allowed."
511 return ${EXIT_ERROR}
512 fi
513
514 if ! isoneof value "ikev1" "ikev2" "IKEV1" "IKEV2"; then
515 log ERROR "Invalid Argument ${value}"
516 return ${EXIT_ERROR}
517 fi
518
519 vpn_security_policies_write_config_key "${name}" "KEY_EXCHANGE" "${value,,}"
520 }
521
522 # This function parses the parameters for the 'lifetime' command.
523 vpn_security_policies_lifetime(){
524 local name=${1}
525 shift
526
527 local value=$@
528
529 # Check if we get only one argument after lifetime <name>
530 if [ ! $# -ge 1 ]; then
531 log ERROR "The number of arguments do not match you must provide at least one integer value or a valid time with the format <hours>h <minutes>m <seconds>s"
532 return ${EXIT_ERROR}
533 fi
534
535 if ! isinteger value; then
536 value=$(parse_time $@)
537 if [ ! $? -eq 0 ]; then
538 log ERROR "Parsing the passed time was not sucessful please check the passed values."
539 return ${EXIT_ERROR}
540 fi
541 fi
542
543 if [ ${value} -le 0 ]; then
544 log ERROR "The passed time value must be in the sum greater zero seconds."
545 return ${EXIT_ERROR}
546 fi
547
548 vpn_security_policies_write_config_key "${name}" "LIFETIME" "${value}"
549 }
550
551 # This function parses the parameters for the 'pfs' command
552 vpn_security_policies_pfs(){
553 local name=${1}
554 local value=${2}
555
556 # Check if we get only one argument after pfs <name>
557 if [ ! $# -eq 2 ]; then
558 log ERROR "The number of arguments do not match. Only argument after pfs is allowed."
559 return ${EXIT_ERROR}
560 fi
561
562 if [ ! $# -eq 2 ] || ! isbool value; then
563 # We suggest only two values to avoid overburding the user.
564 log ERROR "Invalid Argument ${value}"
565 return ${EXIT_ERROR}
566 fi
567
568 vpn_security_policies_write_config_key "${name}" "PFS" "${value}"
569 }
570
571 # This function checks if a vpn security policy name is valid
572 # Allowed are only A-Za-z0-9
573 vpn_security_policies_check_name() {
574 assert [ $# -eq 1 ]
575
576 local name=${1}
577
578 [[ ${name} =~ [^[:alnum:]$] ]]
579 }
580
581 # Function that creates based on the paramters one ore more new vpn security policies
582 vpn_security_policies_new() {
583 if [ $# -gt 1 ]; then
584 error "Too many arguments"
585 return ${EXIT_ERROR}
586 fi
587
588 local name="${1}"
589 if ! isset name; then
590 error "Please provide a name"
591 return ${EXIT_ERROR}
592 fi
593
594 # Check for duplicates
595 if vpn_security_policy_exists "${name}"; then
596 error "The VPN security policy with name ${name} already exists"
597 return ${EXIT_ERROR}
598 fi
599
600 # Check if name is valid
601 if vpn_security_policies_check_name "${name}"; then
602 error "'${name}' contains illegal characters"
603 return ${EXIT_ERROR}
604 fi
605
606 # Check if we have a read-only policy with the same name
607 if vpn_security_policies_check_readonly "${name}"; then
608 error "The VPN security policy ${name} is read-only"
609 return ${EXIT_ERROR}
610 fi
611
612 # Check if our source policy exists
613 if ! vpn_security_policy_exists "${VPN_DEFAULT_SECURITY_POLICY}"; then
614 error "Default VPN Security Policy '${VPN_DEFAULT_SECURITY_POLICY}' does not exist"
615 return ${EXIT_ERROR}
616 fi
617
618 log DEBUG "Creating VPN Security Policy ${name}"
619
620 if copy "$(vpn_security_policies_path "${VPN_DEFAULT_SECURITY_POLICY}")"
621 "$(vpn_security_policies_path ${name})"; then
622 log INFO "VPN Security Policy ${name} successfully created"
623 else
624 log ERROR "Could not create VPN Security Policy ${name}"
625 return ${EXIT_ERROR}
626 fi
627
628 # Show the newly created policy
629 vpn_security_policies_show "${name}"
630 }
631
632 # Function that deletes based on the passed parameters one ore more vpn security policies
633 vpn_security_policies_destroy() {
634 local name
635 for name in $@; do
636 if ! vpn_security_policy_exists ${name}; then
637 log ERROR "The vpn security policy ${name} does not exist."
638 continue
639 fi
640
641 if vpn_security_policies_check_readonly ${name}; then
642 log ERROR "The vpn security policy ${name} cannot be deleted."
643 continue
644 fi
645
646 log DEBUG "Deleting vpn security policy ${name}"
647 settings_remove $(vpn_security_policies_path ${name})
648 done
649 }